/******************************************************************************
 *
 * wincompat.h - defines for non-windows OS. Part of the DirTools project.
 *
 * $Revision: 1.1.1.1 $
 *
 * Copyright (c) 2001-2004 Olivier Castan
 *
 * This program/include file is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program/include file is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (in the main directory of the Linux-NTFS
 * distribution in the file COPYING); if not, write to the Free Software
 * Foundation,Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * format : indent -br -ce -cdw -nut -i5
 *
 *****************************************************************************/

#ifndef _WINCOMPAT_H_
#define _WINCOMPAT_H_ 1

#define TRUE                                    1
#define FALSE                                   0
#define MAXDWORD                      0xFFFFFFFFL
#define ACCESS_ALLOWED_ACE_TYPE                 0
#define ACCESS_DENIED_ACE_TYPE                  1
#define SYSTEM_AUDIT_ACE_TYPE                   2
#define SYSTEM_ALARM_ACE_TYPE                   3
#define OBJECT_INHERIT_ACE                      1
#define CONTAINER_INHERIT_ACE                   2
#define NO_PROPAGATE_INHERIT_ACE                4
#define INHERIT_ONLY_ACE                        8
#define VALID_INHERIT_FLAGS                    16
#define SUCCESSFUL_ACCESS_ACE_FLAG             64
#define FAILED_ACCESS_ACE_FLAG                128
#define DELETE                        0x00010000L
#define READ_CONTROL                     0x20000L
#define WRITE_DAC                        0x40000L
#define WRITE_OWNER                      0x80000L
#define SYNCHRONIZE                     0x100000L
#define STANDARD_RIGHTS_REQUIRED          0xF0000
#define STANDARD_RIGHTS_READ              0x20000
#define STANDARD_RIGHTS_WRITE             0x20000
#define STANDARD_RIGHTS_EXECUTE           0x20000
#define STANDARD_RIGHTS_ALL              0x1F0000
#define SPECIFIC_RIGHTS_ALL                0xFFFF
#define ACCESS_SYSTEM_SECURITY          0x1000000
#define MAXIMUM_ALLOWED                 0x2000000
#define GENERIC_READ                   0x80000000
#define GENERIC_WRITE                  0x40000000
#define GENERIC_EXECUTE                0x20000000
#define GENERIC_ALL                    0x10000000
#define FILE_READ_DATA                          1
#define FILE_LIST_DIRECTORY                     1
#define FILE_WRITE_DATA                         2
#define FILE_ADD_FILE                           2
#define FILE_APPEND_DATA                        4
#define FILE_ADD_SUBDIRECTORY                   4
#define FILE_CREATE_PIPE_INSTANCE               4
#define FILE_READ_EA                            8
#define FILE_READ_PROPERTIES                    8
#define FILE_WRITE_EA                          16
#define FILE_WRITE_PROPERTIES                  16
#define FILE_EXECUTE                           32
#define FILE_TRAVERSE                          32
#define FILE_DELETE_CHILD                      64
#define FILE_READ_ATTRIBUTES                  128
#define FILE_WRITE_ATTRIBUTES                 256
#define FILE_ALL_ACCESS (STANDARD_RIGHTS_REQUIRED|SYNCHRONIZE|0x1FF)
#define FILE_GENERIC_READ (STANDARD_RIGHTS_READ|FILE_READ_DATA|\
                           FILE_READ_ATTRIBUTES|FILE_READ_EA|SYNCHRONIZE)
#define FILE_GENERIC_WRITE (STANDARD_RIGHTS_WRITE|FILE_WRITE_DATA|\
                            FILE_WRITE_ATTRIBUTES|FILE_WRITE_EA|\
                            FILE_APPEND_DATA|SYNCHRONIZE)
#define FILE_GENERIC_EXECUTE (STANDARD_RIGHTS_EXECUTE|FILE_READ_ATTRIBUTES|\
                              FILE_EXECUTE|SYNCHRONIZE)
#define FILE_SHARE_READ                         1
#define FILE_SHARE_WRITE                        2
#define FILE_SHARE_DELETE                       4
#define FILE_ATTRIBUTE_READONLY                 1
#define FILE_ATTRIBUTE_HIDDEN                   2
#define FILE_ATTRIBUTE_SYSTEM                   4
#define FILE_ATTRIBUTE_DIRECTORY               16
#define FILE_ATTRIBUTE_ARCHIVE                 32
#define FILE_ATTRIBUTE_DEVICE                  64
#define FILE_ATTRIBUTE_NORMAL                 128
#define FILE_ATTRIBUTE_TEMPORARY              256
#define FILE_ATTRIBUTE_SPARSE_FILE            512
#define FILE_ATTRIBUTE_REPARSE_POINT         1024
#define FILE_ATTRIBUTE_COMPRESSED            2048
#define FILE_ATTRIBUTE_OFFLINE             0x1000
#define FILE_ATTRIBUTE_NOT_CONTENT_INDEXED 0x2000
#define FILE_ATTRIBUTE_ENCRYPTED           0x4000
#define SE_OWNER_DEFAULTED                      1
#define SE_GROUP_DEFAULTED                      2
#define SE_DACL_PRESENT                         4
#define SE_DACL_DEFAULTED                       8
#define SE_SACL_PRESENT                        16
#define SE_SACL_DEFAULTED                      32
#define SE_DACL_AUTO_INHERIT_REQ              256
#define SE_SACL_AUTO_INHERIT_REQ              512
#define SE_DACL_AUTO_INHERITED               1024
#define SE_SACL_AUTO_INHERITED               2048
#define SE_DACL_PROTECTED                    4096
#define SE_SACL_PROTECTED                    8192
#define SE_SELF_RELATIVE                   0x8000

#define _fcloseall fcloseall

#endif /* _WINCOMPAT_H_ */
