/******************************************************************************
 *
 * winsid.c - convert SID to full name. Part of the DirTools project.
 *
 * $Revision: 1.1.1.1 $
 *
 * Copyright (c) 2001-2004 Olivier Castan
 *
 * This program/include file is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program/include file is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (in the main directory of the Linux-NTFS
 * distribution in the file COPYING); if not, write to the Free Software
 * Foundation,Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * format : indent -br -ce -cdw -nut -i5
 *
 *****************************************************************************/

#ifndef _WINSID_H_
#define _WINSID_H_ 1

#include <windows.h>
#include <stdio.h>

typedef struct _TYPE_SID_INFO
{
     char *pTextualSid;
     char *pCommentSid;
     char *pTypeSid;
     struct _TYPE_SID_INFO *pNext;
} TYPE_SID_INFO, *PTYPE_SID_INFO;

extern FILE *FUserFile;
extern FILE *FSecurDebug;

void InitSecurity ();
int GetSidHash (PSID, const char *, char **, char **);
int FreeSidHash ();

#endif /* _WINSID_H_ */
